# For handling filenames... 
import os
import pygame
import random
import sys

from pygame.locals import *
from game import *
from Config import *
from State import State

opts = 0
if DoubleBuffer:
	opts = opts | pygame.DOUBLEBUF
	
fin = open(os.path.join("res","data","fullscreen.txt"),"r")
fullscreen = (fin.readline().strip() == "1")
fin.close()
if fullscreen:
	opts = opts | pygame.FULLSCREEN
fin = open(os.path.join("res","data","resolution.txt"),"r")
screensize = fin.readline().strip().split("x")
screensize = (int(screensize[0]),int(screensize[1]))
fin.close()
fin = open(os.path.join("res","data","username.txt"),"r")
username = fin.readline().strip()
fin.close()
fin = open(os.path.join("res","data","server.txt"),"r")
server = fin.readline().strip()
fin.close()

screen = pygame.display.set_mode(screensize,opts)
pygame.display.set_caption("Marbles")
pygame.init()

def main(): 
	state = State()
	state.init_state
	state.screen_size = screensize
	state.username = username
	state.double_buffer = DoubleBuffer
	state.fullscreen = fullscreen
	state.framerate = Framerate
	state.server = server
	alive = True
	clock = pygame.time.Clock()
	app = game(screen,clock)
	while alive:
		# Events
		if pygame.event.peek(QUIT):
			alive = False
		events = pygame.event.get()
		
		# Pump events to game
		for event in events:
			app.handle_event(event)
			
		# Update state
		update = app.update()
		# Draw
		app.draw()
		
		# Are we done?
		alive = app.alive
		
		# Did we update anything?
		if update: 
			# if so, redraw screen
			pygame.display.flip()
		
		# Regular framerate
		clock.tick(state.framerate)

if __name__ == '__main__':
	main()

