import pymunk
import pygame
import os
import math
import random
from Loader import Loader

class Ball:
	def __init__(self,physics,pos,radius,mass,collision_type,thickness=1):
		load = Loader()
		self.orig = load.load(os.path.join("res","art",str(radius) +".png"))[0]
		self.surf_size = self.orig.get_size()
		self.surf_size = (self.surf_size[0] / 2, self.surf_size[1] / 2)
		self.surf = pygame.Surface.convert_alpha(self.orig)
		self.space = physics.space
		self.surf.set_alpha(128)
		self.mass = mass
		self.radius = radius
		self.body = pymunk.Body(1,pymunk.moment_for_circle(self.mass,0,self.radius,(0,0)))
		self.shape = pymunk.Circle(self.body,self.radius,(0,0))
		self.shape.body.position=pos
		self.shape.elasticity = 0.9
		self.shape.collision_type = collision_type
		self.space.add(self.body,self.shape)
		self.old_angle = self.body.angle
		self.thickness = thickness
		self.label = False
	
	def update(self):
		if self.old_angle != self.body.angle:
			self.old_angle = self.body.angle
#			self.surf = pygame.transform.rotate(self.orig,self.old_angle * (360/2*math.pi))
		True
	
	def draw(self,surf):
		surf.blit(self.surf,(self.shape.body.position[0]-self.surf_size[0],self.shape.body.position[1]-self.surf_size[1]),None,pygame.locals.BLEND_ADD)
		#pygame.draw.circle(surf,(0,0,0),self.shape.body.position, self.radius, self.thickness)