import pygame
import random
import os
from Config import *
from constants import *
from State import State

import pymunk
import math
import pymunk._chipmunk as cp

class PhysicsManager:
	def __init__(self,damping = 0.90):
		pymunk.init_pymunk()
		self.space = pymunk.Space(10,5)
		self.space.gravity = (0,0)
		self.do_reset = False
		self.state = State()
		self.space.damping = damping
		self.callbacks = {}
	
	def setup_collisions(self):
		self.space.add_collision_handler(TARGET,GLASS,None,None,self.reset,None)
		self.space.add_collision_handler(TARGET,WOOD,None,None,self.reset,None)
		self.space.add_collision_handler(TARGET,RUBBER,None,None,self.reset,None)
		self.space.add_collision_handler(WALL,GLASS,None,None,self.sparks,None)
		self.space.add_collision_handler(WALL,WOOD,None,None,self.sparks,None)
		self.space.add_collision_handler(WALL,RUBBER,None,None,self.sparks,None)
		self.space.add_collision_handler(WALL,TARGET,None,None,self.sparks,None)
		self.space.add_collision_handler(WALL,CUE,None,None,self.sparks,None)
		self.space.add_collision_handler(GLASS,GLASS,None,None,self.sparks,None)
		self.space.add_collision_handler(GLASS,WOOD,None,None,self.sparks,None)
		self.space.add_collision_handler(GLASS,RUBBER,None,None,self.sparks,None)
		self.space.add_collision_handler(GLASS,CUE,None,None,self.sparks,None)
		self.space.add_collision_handler(WOOD,WOOD,None,None,self.sparks,None)
		self.space.add_collision_handler(WOOD,RUBBER,None,None,self.sparks,None)
		self.space.add_collision_handler(WOOD,CUE,None,None,self.sparks,None)
		self.space.add_collision_handler(RUBBER,RUBBER,None,None,self.sparks,None)
		self.space.add_collision_handler(RUBBER,CUE,None,None,self.sparks,None)
		self.space.add_collision_handler(TARGET,CUE,None,None,self.sparks,None)
		return True
		
	def set_callback(self,key,method):
		self.callbacks[key] = method
		
	def reset(self,a,b):
		method = self.callbacks["victory"]
		method()
		return True

	def sparks(self,a,b):
		method = self.callbacks["sparks"]
		if method:
			types = []
			for shape in b.shapes:
				types.append(int(shape.collision_type))
			method(b.contacts[0].position,types)
		return True
	
	def update(self):
		if self.do_reset:
			self.reset_func()
			self.do_reset = False
		for i in range(0,3):
			self.space.step(1/40.0)
		
	def draw(self,surf):
		return True