import pygame

class SurfaceButton:
	def __init__(self,surface,coords):
		self.surface = surface
		self.coords = coords
		self.size = self.surface.get_size()
		self.highlight = False
	
	def update(self):
		return True

	def draw(self,surf):
		surf.blit(self.surface, self.coords)
		pygame.draw.rect(surf,(64,64,64),pygame.Rect(self.coords[0],self.coords[1],self.size[0],self.size[1]),1)
		if self.highlight:
			pygame.draw.rect(surf,(255,255,255),pygame.Rect(self.coords[0]-2,self.coords[1]-2,self.size[0]+4,self.size[1]+4),2)
		return True
	
	def mouse_in(self,coords):
		if pygame.Rect(self.coords[0],self.coords[1],self.size[0],self.size[1]).collidepoint(coords):
			self.highlight = True
			return True
		self.highlight = False
		return False

	def click(self,coords):
		return self.mouse_in(coords)