import pymunk
import pygame
from constants import *

class Wall:
	def __init__(self, space, position, end_a, end_b, type=WALL, width=2):
		self.space = space
		self.body = pymunk.Body(1e100,1e100)
		self.body.position = position
		self.shape = pymunk.Segment(self.body,end_a,end_b,width)
		self.shape.collision_type = type
		self.shape.elasticity = 1.0
		self.space.add_static(self.shape)
		self.end_a = end_a
		self.end_b = end_b
		self.width = width
		self.color = (255,255,255)
	
	def update_x(self,x):
		self.space.remove_static(self.shape)
		self.body.position.x = x
		self.space.add_static(self.shape)
		
	def draw(self,surface):
		pygame.draw.aaline(surface,self.color,(self.body.position[0] + self.end_a[0], self.body.position[1] + self.end_a[1]), (self.body.position[0] + self.end_b[0],self.body.position[1] + self.end_b[1]),self.width)
		return True
		
	def update(self):
		return True
