import pygame
import os
import sys
from pygame.locals import *
from Label import Label
from AbstractScreen import AbstractScreen
from Loader import Loader

class UsernameScreen(AbstractScreen):
	def __init__(self):
		AbstractScreen.__init__(self)
		y = 200
		font = Loader().load_font("slkscr",16)
		self.large_font = Loader().load_font("slkscr",48)
		for string in ["Before you can upload courses you'll have to create a username.",
									 "Just type it in (letters, numbers, and spaces allowed) now and",
									 "press `Enter' when you're done!"]:
			lbl = Label(string,font,(255,255,255),(100,y))
			self.attach(lbl)
			y += lbl.size[1]+10
		self.username = ""
		self.username_lbl = False
	
	def on_focus(self):
		return True
	
	def draw(self,screen):
		screen.fill( (0,0,0) )
		AbstractScreen.draw(self,screen)
		return True
	
	def update(self):
		AbstractScreen.update(self)
		return True

	def handle_event(self,event):
		if event.type == KEYDOWN:
			print event.key
			if (event.key >= 97 and event.key <= 122) or (event.key >= 48 and event.key <= 57) or event.key == 32: # character
				self.username += chr(event.key)
				if self.username_lbl:
					self.stage.remove(self.username_lbl)
				self.username_lbl = Label(self.username,self.large_font,(255,255,255),(0,self.state.screen_size[1]/2-10))
				self.username_lbl.set_x(self.state.screen_size[0]/2-self.username_lbl.size[0]/2)
				self.attach(self.username_lbl)
			elif event.key == 8 and len(self.username) > 0: # delete
				self.username = self.username[0:-1]
				if self.username_lbl:
					self.stage.remove(self.username_lbl)
				self.username_lbl = Label(self.username,self.large_font,(255,255,255),(0,self.state.screen_size[1]/2-10))
				self.username_lbl.set_x(self.state.screen_size[0]/2-self.username_lbl.size[0]/2)
				self.attach(self.username_lbl)
			elif event.key == 13 and len(self.username) > 2: # Enter
				self.state.username = self.username
				fout = open(os.path.join("res","data","username.txt"),"w")
				fout.write(self.username + "\n")
				fout.close()
				self.state.game.switch_to(4)
		return True
		#return False